global readmsr
global writemsr
global setcr4bit
global clearcr4bit

; /syntax/ void readmsr(unsigned long msr, unsigned long *val1, unsigned long *val2);
readmsr:
	push ebp
	mov ebp, esp
	push esi
	push ebx
	mov ebx, [ebp+12]
	mov esi, [ebp+16]
	mov ecx, [ebp+8]
	rdmsr
	mov [ebx], eax
	mov [esi], edx
	pop ebx
	pop esi
	mov esp, ebp
	pop ebp
	ret
; /syntax/ void wrmsr(unsigned long msr, unsigned long val1, unsigned long val2);
writemsr:
	push ebp
	mov ebp, esp
	mov ecx, [ebp+8]
	mov eax, [ebp+12]
	mov edx, [ebp+16]
	wrmsr
	mov esp, ebp
	pop ebp
	ret
; /syntax/ void setcr4bit(unsigned long mask);
setcr4bit:
	push ebp
	mov ebp, esp
	mov eax, cr4
	or eax, [ebp+8]
	mov cr4, eax
	mov esp, ebp
	pop ebp
	ret

; /syntax/ void clearcr4bit(unsigned long mask);
clearcr4bit:
	push ebp
	mov ebp, esp
	mov edx, [ebp+8]
	xor edx, 1
	mov eax, cr4
	and eax, edx
	mov cr4, eax
	mov esp, ebp
	pop ebp
	ret
	