#include <unistd.h>
#include <fcntl.h>
#include <iostream>
#define SSEENABLE 'si'
#define SSEDISABLE 'di'

int main(int argc, char *argv[])
{
	bool enable = false;
	if(argc <= 1) {
		cout << "This program should only be used with Athlon XP processors\n\n";
		cout << "To enable SSE, use the following: \n" << argv[0] << " -enablesse\n\n";
		cout << "To disable SSE, use the following: \n" << argv[0] << " -disablesse\n\n";
		cout << "Disclaimer: You are using this program at your own risk\n";
		return(true);
	} 
	int fd = open("/dev/misc/xpsse", O_RDWR | O_NONBLOCK);
	
	if(!fd) {
		cout << "error: please check if the driver is installed\n";
		return(true);
	}
	
	if(strcmp(argv[1], "-enablesse") == 0) {
		cout << "Now enabling SSE on your Athlon Xp\n";
		ioctl(fd, SSEENABLE, NULL, 0);
		enable = true;
	} else if(strcmp(argv[1], "-disablesse") == 0) {
		cout << "Now disabling SSE on your Athlon Xp\n";
		ioctl(fd, SSEDISABLE, NULL, 0);
	} else {
		cout << "Incorrect paramater\n";
		return(true);
	}
	close(fd);
	if(enable) {
		cout << "Testing if SSE instructions can be used\n";
		asm("xorps %xmm0, %xmm0");
		cout << "SSE instructions are now available for usage\n";
	}
	return(0);
}